aboutsummaryrefslogtreecommitdiffstats
path: root/mcp/scripts/lib.sh
diff options
context:
space:
mode:
authorAlexandru Avadanii <Alexandru.Avadanii@enea.com>2017-08-01 22:18:41 +0200
committerAlexandru Avadanii <Alexandru.Avadanii@enea.com>2017-08-17 02:59:30 +0200
commit5039d069265df15ed3d8e41f7a1c7f9457a9d58a (patch)
tree18a9160f72be9a01ef0008e3aa9912e18262057d /mcp/scripts/lib.sh
parent9720ddf955b76d678a08dc7ea53684400c659ce3 (diff)
Bring in baremetal support
- ci/deploy.sh: fail if default scenario file is missing; - start by copying reclass/classes/cluster/virtual-mcp-ocata-ovs as classes/cluster/baremetal-mcp-ocata-ovs; - add new state (maas) that will handle MaaS configuration; - Split PXE network in two for baremetal: * rename old "pxe" virtual network to "mcpcontrol", make it non-configurable and identical for baremetal/virtual deploys; * new "pxebr" bridge is dedicated for MaaS fabric network, which comes with its own DHCP, TFTP etc.; - Drop hardcoded PXE gateway & static IP for MaaS node, since "mcpcontrol" remains a NAT-ed virtual network, with its own DHCP; - Keep internet access available on first interfaces for cfg01/mas01; - Align MaaS IP addrs (all x.y.z.3), add public IP for easy debug via MaaS dashboard; - Add static IP in new network segment (192.168.11.3/24) on MaaS node's PXE interface; - Set MaaS PXE interface MTU 1500 (weird network errors with jumbo); - MaaS node: Add NAT iptables traffic forward from "mcpcontrol" to "pxebr" interfaces; - MaaS: Add harcoded lf-pod2 machine info (fixed identation in v6); - Switch our targeted scenario to HA; * scenario: s/os-nosdn-nofeature-noha/os-nosdn-nofeature-ha/ - maas region: Use mcp.rsa.pub from ~ubuntu/.ssh/authorized_keys; - add route for 192.168.11.0/24 via mas01 on cfg01; - fix race condition on kvm nodes network setup: * add "noifupdown" support in salt formula for linux.network; * keep primary eth/br-mgmt unconfigured till reboot; TODO: - Read all this info from PDF (Pod Descriptor File) later; - investigate leftover references to eno2, eth3; - add public network interfaces config, IPs; - improve wait conditions for MaaS commision/deploy; - report upstream breakage in system.single; Change-Id: Ie8dd584b140991d2bd992acdfe47f5644bf51409 Signed-off-by: Michael Polenchuk <mpolenchuk@mirantis.com> Signed-off-by: Guillermo Herrero <Guillermo.Herrero@enea.com> Signed-off-by: Charalampos Kominos <Charalampos.Kominos@enea.com> Signed-off-by: Alexandru Avadanii <Alexandru.Avadanii@enea.com>
Diffstat (limited to 'mcp/scripts/lib.sh')
-rw-r--r--mcp/scripts/lib.sh50
1 files changed, 28 insertions, 22 deletions
diff --git a/mcp/scripts/lib.sh b/mcp/scripts/lib.sh
index 8d4510084..28b11e144 100644
--- a/mcp/scripts/lib.sh
+++ b/mcp/scripts/lib.sh
@@ -46,10 +46,12 @@ prepare_vms() {
create_networks() {
local -n vnode_networks=$1
- # create required networks
- for net in "${vnode_networks[@]}"; do
+ # create required networks, including constant "mcpcontrol"
+ # FIXME(alav): since we renamed "pxe" to "mcpcontrol", we need to make sure
+ # we delete the old "pxe" virtual network, or it would cause IP conflicts.
+ for net in "pxe" "mcpcontrol" "${vnode_networks[@]}"; do
if virsh net-info "${net}" >/dev/null 2>&1; then
- virsh net-destroy "${net}"
+ virsh net-destroy "${net}" || true
virsh net-undefine "${net}"
fi
# in case of custom network, host should already have the bridge in place
@@ -67,17 +69,6 @@ create_vms() {
local -n vnodes_vcpus=$3
local -n vnode_networks=$4
- # prepare network args
- net_args=""
- for net in "${vnode_networks[@]}"; do
- net_type="network"
- # in case of custom network, host should already have the bridge in place
- if [ ! -f "net_${net}.xml" ]; then
- net_type="bridge"
- fi
- net_args="${net_args} --network ${net_type}=${net},model=virtio"
- done
-
# AArch64: prepare arch specific arguments
local virt_extra_args=""
if [ "$(uname -i)" = "aarch64" ]; then
@@ -87,6 +78,21 @@ create_vms() {
# create vms with specified options
for node in "${vnodes[@]}"; do
+ # prepare network args
+ net_args=" --network network=mcpcontrol,model=virtio"
+ if [ "${node}" = "mas01" ]; then
+ # MaaS node's 3rd interface gets connected to PXE/Admin Bridge
+ vnode_networks[2]="${vnode_networks[0]}"
+ fi
+ for net in "${vnode_networks[@]:1}"; do
+ net_type="network"
+ # in case of custom network, host should already have the bridge in place
+ if [ ! -f "net_${net}.xml" ]; then
+ net_type="bridge"
+ fi
+ net_args="${net_args} --network ${net_type}=${net},model=virtio"
+ done
+
# shellcheck disable=SC2086
virt-install --name "${node}" \
--ram "${vnodes_ram[$node]}" --vcpus "${vnodes_vcpus[$node]}" \
@@ -100,14 +106,14 @@ create_vms() {
done
}
-update_pxe_network() {
- local -n vnode_networks=$1
- if virsh net-info "${vnode_networks[0]}" >/dev/null 2>&1; then
- # set static ip address for salt master node, only if managed via virsh
- # NOTE: below expr assume PXE network is always the first in domiflist
- virsh net-update "${vnode_networks[0]}" add ip-dhcp-host \
- "<host mac='$(virsh domiflist cfg01 | awk '/network/ {print $5; exit}')' name='cfg01' ip='${SALT_MASTER}'/>" --live
- fi
+update_mcpcontrol_network() {
+ # set static ip address for salt master node, MaaS node
+ local cmac=$(virsh domiflist cfg01 2>&1| awk '/mcpcontrol/ {print $5; exit}')
+ local amac=$(virsh domiflist mas01 2>&1| awk '/mcpcontrol/ {print $5; exit}')
+ virsh net-update "mcpcontrol" add ip-dhcp-host \
+ "<host mac='${cmac}' name='cfg01' ip='${SALT_MASTER}'/>" --live
+ [ -z "${amac}" ] || virsh net-update "mcpcontrol" add ip-dhcp-host \
+ "<host mac='${amac}' name='mas01' ip='${MAAS_IP}'/>" --live
}
start_vms() {